---
id: reference-rest-api-overview
title: Pulsar REST APIs
sidebar_label: "Pulsar REST APIs"
---

A REST API (also known as RESTful API, REpresentational State Transfer Application Programming Interface) is a set of definitions and protocols for building and integrating application software, using HTTP requests to GET, PUT, POST, and DELETE data following the REST standards. In essence, REST API is a set of remote calls using standard methods to request and return data in a specific format between two systems. 

Pulsar provides a variety of REST APIs that enable you to interact with Pulsar to retrieve information or perform an action. 

| REST API category | Description |
| --- | --- |
| [Admin](/admin-rest-api/?version=master) | REST APIs for administrative operations.|
| [Functions](/functions-rest-api/?version=master) | REST APIs for function-specific operations.|
| [Sources](/source-rest-api/?version=master) | REST APIs for source-specific operations.|
| [Sinks](/sink-rest-api/?version=master) | REST APIs for sink-specific operations.|
| [Packages](/packages-rest-api/?version=master) | REST APIs for package-specific operations. A package can be a group of functions, sources, and sinks.|
| [Transactions](/transactions-rest-api/?version=master) | REST APIs for transaction-specific operations.|

