---
author: Alice Bi, Karin Landers
title: "Speakers and Sponsorship Prospectus Announced for Pulsar Summit San Francisco 2022"
date: 2022-07-15
---

We're excited to invite you to [the Pulsar Summit San Francisco 2022](https://pulsar-summit.org/event/san-francisco-2022)! Join the Apache Pulsar community in-person at Hotel Nikko on August 18th for this action-packed, one-day event. Don’t miss the opportunity to join us for four keynotes and 12 breakout sessions and to network with fellow attendees at the Happy Hour event. [Save your spot](https://www.eventbrite.com/e/pulsar-summit-san-francisco-2022-tickets-332014162297).

<!--truncate-->

The Pulsar Summit gathers developers, architects, and data engineers to discuss the latest in real-time data streaming and message queuing. Past Pulsar Summits have featured more than 200 interactive sessions presented by tech leaders from Intuit, Micro Focus, Salesforce, Splunk, Verizon Media, Tencent, and more. The Summits garnered 2,000+ global attendees representing top technology, fintech, and media companies, such as Google, Amazon, eBay, Microsoft, American Express, LEGO, Athena Health, Paypal, and many more. 

This year, Pulsar Summit San Francisco will include tech deep dives, adoption stories, best practices, and insights into Pulsar’s global adoption and thriving community. Take a sneak peek below at a few of the featured sessions:

## Featured Sessions

### 1. Message Redelivery: An Unexpected Journey

**David Kjerrumgaard, Developer Advocate, StreamNative**

Understanding Pulsar’s redelivery semantics is critical for preventing duplicate or out-of-order processing when message acknowledgments are not received. This talk walks you through the redelivery semantics, highlights some of the mechanisms available to application developers to control this behavior, and provides best practices for configuring message redelivery to suit various use cases.

### 2. Is Using KoP (Kafka-On-Pulsar) a Good Idea?

**Ricardo Ferreira, Senior Developer Advocate, AWS**

Learn how to unlock infinite event stream retention, a rebalance-free architecture, native support for event processing, and the multi-tenancy with Apache Pulsar for your microservices written for Apache Kafka. This talk dives into the architecture of protocol handlers and how KoP (Kafka-on-Pulsar) works.

### 3. Cross the Streams! Creating Streaming Data Pipelines with Apache Flink + Apache Pulsar

**Caito Scherr, Developer Advocate, Ververica** 

Learn how to build a unified batch and streaming pipeline from scratch with Apache Pulsar and Flink SQL in this step-by-step demo. Leverage the power of Apache Flink, a high-speed, customizable stream processing engine, without the steep learning curve.  

### 4. Building Reliable Lakehouses with Apache Pulsar and Delta Lake

**Denny Lee, Sr. Staff Developer Advocate and Delta Lake Committer, Databricks**

Explore the key features of Delta Lake that enable the Lakehouse architecture. Learn about the future ecosystem around Delta Lake, including supporting multiple languages and data processing systems. 

### 5. Towards a ZooKeeper-less Pulsar, etcd, etcd, etcd.

**Matteo Merli, Apache Pulsar PMC Chair, CTO, StreamNative**

Apache Pulsar 2.10 eliminates Pulsar’s dependency on Apache ZooKeeper and introduces a pluggable framework to enable leveraging alternative metadata and coordination systems. Learn how to utilize the existing etcd service running inside Kubernetes to act as Pulsar's metadata store, achieving a Zookeeper-less Pulsar.

For more information, see the [Pulsar Summit schedule](https://pulsar-summit.org/event/san-francisco-2022/schedule) and [speaker list](https://pulsar-summit.org/event/san-francisco-2022/speakers).

## Two ways to participate:

1. [Sign up to attend.](https://www.eventbrite.com/e/pulsar-summit-san-francisco-2022-tickets-332014162297)
2. Become a sponsor! Learn how your company can stand out as a thought leader in the fast-growing Apache Pulsar community by becoming a Summit Sponsor. [Learn more](https://6585952.fs1.hubspotusercontent-na1.net/hubfs/6585952/Pulsar%20Summit%20San%20Francisco%202022%20Sponsorship%20Prospectus%20v.2.pdf) about the limited Sponsorship opportunities available, and secure your sponsorship by emailing: sponsors@pulsar-summit.org. 

### **[Register Now!](https://www.eventbrite.com/e/pulsar-summit-san-francisco-2022-tickets-332014162297)**

## More Resources

1. **Download and try out the latest version of Pulsar**. Recently, the Apache Pulsar community released [version 2.10.1](https://pulsar.apache.org/versions/). 50 contributors provided improvements and bug fixes that delivered 200+ commits. For more information, see [What’s New in Apache Pulsar 2.10.1](https://pulsar.apache.org/blog/2022/07/12/Apache-Pulsar-2-10-1).
2. **Meet the Apache Pulsar community**. [Subscribe to the Pulsar mailing lists](https://pulsar.apache.org/community#section-welcome) for user-related or Pulsar development discussions. You can also [join the Pulsar Slack](https://apache-pulsar.herokuapp.com/) for quick questions or join discussions on specialized topics.