---
slug: /
id: about
title: Welcome to the doc portal!
sidebar_label: "About"
---

import BlockLinks from "@site/src/components/BlockLinks";
import BlockLink from "@site/src/components/BlockLink";
import { docUrl } from "@site/src/utils/index";


# Welcome to the doc portal!
***

This portal holds a variety of support documents to help you work with Pulsar . If you’re a beginner, there are tutorials and explainers to help you understand Pulsar and how it works.

If you’re an experienced coder, review this page to learn the easiest way to access the specific content you’re looking for.

## Get Started Now
<BlockLinks>
    <BlockLink title="About Pulsar" url="/docs/2.9.2/concepts-overview/" />
    <BlockLink title="Get Started" url="/docs/2.9.2/getting-started-standalone/" />
    <BlockLink title="Install, Deploy, Upgrade" url="/docs/2.9.2/deploy-aws/" />
    <BlockLink title="Pulsar for Developers" url="/docs/2.9.2/develop-tools/" />
    <BlockLink title="How To" url="/docs/2.9.2/functions-develop/" />
    <BlockLink title="References" url="/docs/2.9.2/reference-terminology/" />
</BlockLinks>

## Navigation
***

There are several ways to get around in the doc portal. The index navigation pane is a table of contents for the entire archive. The archive is divided into sections, like chapters in a book. Click the title of the topic to view it.

In-context links provide an easy way to immediately reference related topics. Click the underlined term to view the topic.

Links to related topics can be found at the bottom of each topic page. Click the link to view the topic.

![Page Linking](/assets/page-linking.png)

## Continuous Improvement
***
As you probably know, we are working on a new user experience for our documentation portal that will make learning about and building on top of Apache Pulsar a much better experience. Whether you need overview concepts, how-to procedures, curated guides or quick references, we’re building content to support it. This welcome page is just the first step. We will be providing updates every month.

## Help Improve These Documents
***

You’ll notice an Edit button at the bottom and top of each page. Click it to open a landing page with instructions for requesting changes to posted documents. These are your resources. Participation is not only welcomed – it’s essential!

## Join the Community!
***

The Pulsar community on github is active, passionate, and knowledgeable.  Join discussions, voice opinions, suggest features, and dive into the code itself. Find your Pulsar family here at [apache/pulsar](https://github.com/apache/pulsar).

An equally passionate community can be found in the [Pulsar Slack channel](https://apache-pulsar.slack.com/). You’ll need an invitation to join, but many Github Pulsar community members are Slack members too.  Join, hang out, learn, and make some new friends.

